Attribute VB_Name = "misc"
#If Win32 Then

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" _
    (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, _
    ByVal lpParameters As String, ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) As Long
#Else

Private Declare Function ShellExecute Lib "shell.dll" (ByVal hwnd As Integer, _
    ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, _
    ByVal lpDirectory As String, ByVal nShowCmd As Integer) As Integer
#End If

Private Const SW_SHOWNORMAL = 1

Public Function WebURL(ByVal URL As String) As Long
    WebURL = ShellExecute(0&, vbNullString, URL, vbNullString, vbNullString, vbNormalFocus)
End Function

Public Function serializeCommand(com As command) As String

    serializeCommand = com.type & Chr(17) & com.fromIP & Chr(17) & com.value

End Function

Public Function deSerializeCommand(com As String) As command
    On Error Resume Next

    deSerializeCommand.type = GetToken(com, 1, Chr(17))
    deSerializeCommand.fromIP = GetToken(com, 2, Chr(17))
    deSerializeCommand.value = GetToken(com, 3, Chr(17))

End Function


'***************************************************************
' Name: GetToken
' Description:The following code is a Visual Basic function that
'     returns a specific "token" (section/substring of data) from a del
'     imited string list. The function accepts the index of the desired
'     token and also the delimiter as specified by the programmer.
' By: Troy DeMonbreun
'
'
' Inputs:Requires : [string] delimited data, [integer] index of d
'     esired section, [string] delimiter (1 or more chars)
'
' Returns:Returns : [string] "Token" (section of data) from a lis
'     t of delimited string data
'
'Assumes:Examples:
'GetToken("steve@hotmail.com", 2, "@") returns "hotmail.com"
'GetToken("first,second,third", 2, ",") returns "second"
'GetToken("111, 222, 333", 3, ", ") returns "333"
'GetToken("line1" + vbCrLf + "line2" + vbCrLf + "line3", 2, vbCrLf) returns "line2"
'
'Side Effects:None
'
'Code provided by Planet Source Code(tm) (http://www.PlanetSource
'     Code.com) 'as is', without warranties as to performance, fitness,
'     merchantability,and any other warranty (whether expressed or impl
'     ied).
'***************************************************************



Function GetToken(ByVal strVal As String, intIndex As Integer, strDelimiter As String) As String
    '----------------------------------------------------------------
    '     --------
    ' Author: Troy DeMonbreun (vb@8x.com)
    '
    ' Returns : [string] "Token" (section of data) from a list of
    'delimited string data
    '
    ' Requires : [string] delimited data,
    '[integer] index of desired section,
    '[string] delimiter (1 or more chars)
    '
    ' Examples : GetToken("steve@hotmail.com", 2, "@") returns "hotma
    '     il.com"
    'GetToken("123-45-6789", 2, "-") returns "45"
    'GetToken("first,middle,last", 3, ",") returns "last"
    '
    ' Revised : 12/22/1998
    '----------------------------------------------------------------
    '     --------
    Dim strSubString() As String
    Dim intIndex2 As Integer
    Dim i As Integer
    Dim intDelimitLen As Integer
    intIndex2 = 1
    i = 0
    intDelimitLen = Len(strDelimiter)
    Do While intIndex2 > 0
        ReDim Preserve strSubString(i + 1)
        intIndex2 = InStr(1, strVal, strDelimiter)
        If intIndex2 > 0 Then
            strSubString(i) = Mid(strVal, 1, (intIndex2 - 1))
            strVal = Mid(strVal, (intIndex2 + intDelimitLen), Len(strVal))
        Else
            strSubString(i) = strVal
        End If
        i = i + 1
    Loop
    If intIndex > (i + 1) Or intIndex < 1 Then
        GetToken = ""
    Else
        GetToken = strSubString(intIndex - 1)
    End If
End Function

Public Function lookUpUserByIP(IP As String) As Integer
    On Error Resume Next

    For X = 0 To contactList.Count - 1

        If contactList(X).IP = IP Then
            lookUpUserByIP = X
            Exit Function
        End If

    Next X

End Function

Public Function IPexists(IP As String) As Boolean
    On Error Resume Next

    IPexists = False

    For X = 0 To contactList.Count - 1

        If contactList(X).IP = IP Then
            IPexists = True
            Exit Function
        End If

    Next X

End Function

Public Function neutralizeFont(box As RichTextBox)

    box.SelFontName = "FixedSys"
    box.SelFontSize = 9
    box.SelStrikeThru = False
    box.SelUnderline = False
    box.SelItalic = False
    box.SelBold = False

End Function
